// ============================================================================
// Movo Network API Sample
//
// <CPP_ApiSample2.cpp>
//
// Copyright (c) 2008 Servoland corporation.
// All rights reserved.
//
// ړIF
//		DDAsAvP[V쐬܂B
//
// VersionF					  -- ǉ, C --
//		Version 1.0		2008.08.11	: First construction.
//
// ============================================================================

#include "stdafx.h"

using namespace System;
using namespace MovoEtherVB::Servoland;

public ref class CPP_ApiSample2
{
private:
	MovoAPI^ api;
	int iDevSel;
public:
	// ========================================================================
	// 
	// ========================================================================
	int Initialize()
	{
        String^ strBuf = ""; // obt@
        int i;              // Counter
        int iRc;            // Return code
        int IFNum;          // Ethernet I/F̐
        int IFSel;          // gpEthetnet I/F
        String^ strIP = "";  // IPAhX()
        int pIP=0;          // IPAhX()
        String^ strSN = "";  // Tulbg}XN()
        int pSN=0;          // Tulbg}XN()

        api = gcnew MovoAPI(); // MovoAPINX̃CX^X

        iDevSel = 0; // ʐMfoCX=Ethernet

        // APĨo[W擾
        api->GetLibVersion(strBuf);
        strBuf = "Network API version " + strBuf + "\n";

		Console::WriteLine(strBuf);

        // I/Fݒ(Ethernetgp)
        if (iDevSel == 0)
        {
            // gp\Ethernet I/F
            IFNum = api->SearchInterface(iDevSel);
            if (IFNum < 0)
            {
				Console::WriteLine("No ethernet I/F found");
                return -1;
            }

			Console::WriteLine(IFNum.ToString() + " ethernet I/F found");

            // eI/F̏\
            for (i = 0; i < IFNum; i++)
            {
                api->GetHostIP(iDevSel, i, strIP, pIP);
                api->GetHostSN(iDevSel, i, strSN, pSN);
				Console::WriteLine(i.ToString() + " : " + String::Format("{0,-16}", strIP) + "(" + String::Format("{0,-16}", strSN) + ")");
            }

            if (IFNum == 1)
            {
                // I/FP̂Ƃ͎I
                IFSel = 0;
            }
            else
            {
                // I/FQȏ̂Ƃ̓[UI
                do
                {
                    Console::Write("Select I/F to use [0-" + (IFNum - 1).ToString() + "]> ");
                    strBuf = Console::ReadLine();
                    try
                    {
						
						IFSel = Convert::ToInt32(strBuf);
                    }
                    catch(...)
                    {
                        IFSel = -1;
                    }
                } while (IFSel < 0 || IFSel >= IFNum);

            }
            Console::WriteLine("I/F " + IFSel.ToString() + " selected\n");

            // Ethernet I/Fݒ
            api->SetInterface(iDevSel, IFSel);
        }

        // ڑꂽhCǒ
        iRc = api->SearchDevice(iDevSel, strBuf);
        if (iRc <= 0)
        {
            Console::WriteLine("No driver found");
            return -1;
        }

        // ڑ\ȂׂẴhCoɐڑ
        iRc = api->ConnectAll(iDevSel, strBuf);
        if (iRc > 0)
        {
            Console::WriteLine("Driver " + strBuf + " connected");
        }
        else
        {
            Console::WriteLine("No driver found");
            return -1;
        }
        return 0;
	}
    // =====================================================================
    // R}hҋ@
    //		istrCom̕ԓstrAnsƈv܂Pollingj
    // =====================================================================
    int WaitCommand(Char ID, String^ strCom, String^ strAns){
        int iRc=0;
        String^ strBuf;

        do{
            strBuf = ID.ToString() + ":" + strCom;
	        iRc=api->SendCom(iDevSel,strBuf);
			if (iRc == MovoAPI::MOVO_HASDATA)
            {
		        iRc=api->RecvCom(iDevSel,strBuf);
            }
			else if (iRc == MovoAPI::MOVO_NODATA)
            {
				Console::WriteLine("Wrong usage");
		        return -1;
	        }else{
		        api->GetErrorText(iDevSel,strBuf);
				Console::WriteLine(ID.ToString()+":Error [" + strBuf + "]");
		        return iRc;
	        }
        }while(strBuf!=strAns);

        return iRc;
    }

	// ========================================================================
	// DDAs
	// ========================================================================
	int ExecDda()
	{
        const int DRV_NUM=2;
        const int DDA_LINE = 10000;
		const int size=MovoAPI::MOVO_MAX_DDA;	// őf[^]

        String^ strID="";		// hCo̎Xg
        String^ strBuf;	    // Mobt@
        int flStart;		// 쓮tO
        int i;				// ėpJE^
        int j;				// DDAJE^
        int k;				// ėpJE^
        int Drv;			// ΏۂƂȂhCo̔ԍ
        int iRc;			// Return code
        int data_num;		// f[^
        int all_fixed;		// StO
        int send_num;			// ̃f[^]
        array<int>^ finished=gcnew array<int>(DRV_NUM);	// DDAtO
        array<int>^ comp_num=gcnew array<int>(DRV_NUM);	// ]ς݃f[^
        array<int>^ rest_num=gcnew array<int>(DRV_NUM);	// cf[^
        array<int>^ fix_num=gcnew array<int>(DRV_NUM);	// O擾

        DDA_INFO CInfo;		// DDA_INFO\

        array<DDA_DATA,2>^ DdaData=gcnew array<DDA_DATA,2>(DRV_NUM,DDA_LINE);	// DDAf[^
        array<DDA_DATA,2>^ LogData=gcnew array<DDA_DATA,2>(DRV_NUM,DDA_LINE+1);	// Logf[^
        DDA_DATA dummydata;

        String^ filename="log.csv";
		System::IO::StreamWriter^ logfile;
    	
        iRc=api->GetConnectedDeviceInfo(iDevSel,strID);
        if(iRc<DRV_NUM){
            Console::WriteLine("Not enough drivers found");
	        return -1;
        }

        // eXgpcc`f[^쐬
        //i[^̓ϑłx̎ړxɂj
        for(i=0;i<DDA_LINE;i++){
	        for(Drv=0;Drv<DRV_NUM;Drv++){
				DdaData[Drv,i].data32=(int)(1000000*Math::Sin(2*Math::PI*5 * i/DDA_LINE));
				DdaData[Drv,i].trj32=i;
	        }
        }

        flStart=0;			// 쓮tO
        all_fixed=0;		// StO
        data_num=DDA_LINE;	// DDAf[^s

        for(Drv=0;Drv<DRV_NUM;Drv++){
	        finished[Drv]=0;		// DDAtO
	        comp_num[Drv]=0;		// ]ς݃f[^
	        rest_num[Drv]=data_num;	// cf[^
	        fix_num[Drv]=0;			// O擾
        }

        for(Drv=0;Drv<DRV_NUM;Drv++){
	        if(Drv==0){
		        // Masterɐݒ
                strBuf = strID[Drv].ToString() + ":#70=1";
	        }else{
		        // cSlaveɐݒ
                strBuf = strID[Drv].ToString() + ":#70=2";
	        }
	        iRc=api->SendCom(iDevSel,strBuf);
			if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;
        }

        // SlaveSYNCS1ɂȂ̂҂(Master͏0)
        iRc=WaitCommand((char)strID[1],"SYNCS","1");
        strBuf = "*:MASK";
        iRc=api->SendCom(iDevSel,strBuf);
        if (iRc == MovoAPI::MOVO_FAILURE) goto COM_ERR;

        // T[{ON
        strBuf="*:SVON";
        iRc=api->SendCom(iDevSel,strBuf);
        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;

        // Wait for SVON
        for(Drv=0;Drv<DRV_NUM;Drv++){
	        iRc=WaitCommand((char)strID[Drv],"SVONS","1");
	        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;
        }

        // DDA[hɐݒ
        strBuf="*:DDA";
        iRc=api->SendCom(iDevSel,strBuf);
        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;

        // LINKJn
        strBuf="*:LINK=1";
        iRc=api->SendCom(iDevSel,strBuf);
        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;

        // DDA
        for(Drv=0;Drv<DRV_NUM;Drv++){
	        iRc=api->InitDda(
		        iDevSel,	// Device select
		        strID[Drv],	// ݒ
		        0,			// 1ms TvO
		        1,			// wߒlƃOp
		        1,			// feed forward on
		        CInfo);	// DDA_INFO\̂ւ̃|C^
	        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;
        }

        // DDAf[^ݒ
        Drv=0;
        for(;;){
	        // tO
	        if(finished[Drv]==1){
		        if(++Drv>=DRV_NUM)
			        Drv=0;
		        continue;
	        }
	        // Pɑf[^ݒ
	        if(rest_num[Drv]==0){			// cf[^Ȃ
		        send_num=0;
		        all_fixed++;
	        }else if(rest_num[Drv]>size){	// cf[^ő]
		        send_num=size;
	        }else{
		        send_num=rest_num[Drv];
	        }

	        if(all_fixed==DRV_NUM){
		        // Sobt@ւ̃f[^]
		        for(k=0;k<DRV_NUM;k++){
			        strBuf = strID[k].ToString() + ":G";
			        iRc=api->SendCom(iDevSel, strBuf);	// 쓮
			        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;
		        }
		        flStart=1;	// 쓮tOݒ
	        }

	        // DDAf[^ݒ
			if(flStart==1){
				if(send_num==0){
					iRc=api->SetDda(iDevSel,strID[Drv],send_num,dummydata,LogData[Drv,fix_num[Drv]],CInfo);
				}else{
					iRc=api->SetDda(iDevSel,strID[Drv],send_num,DdaData[Drv,comp_num[Drv]],LogData[Drv,fix_num[Drv]],CInfo);
				}
			}else
                iRc = api->SetDda(iDevSel, strID[Drv], send_num, DdaData[Drv, comp_num[Drv]], dummydata, CInfo);
            if (iRc == MovoAPI::MOVO_FAILURE) goto COM_ERR;

	        // OZ
	        if(flStart==1)
		        fix_num[Drv]+=CInfo.log_num;

	        // BusytO`FbN
	        if(CInfo.busy==1){	// hCôcc`̈悪t
		        if(flStart==0){
			        // Ώێ̃obt@ւ̃f[^]
			        for(k=0;k<DRV_NUM;k++){
                        strBuf = strID[k].ToString() + ":G";
				        iRc=api->SendCom(iDevSel, strBuf);	// 쓮
						if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;
			        }
			        flStart=1;	// 쓮tOݒ
		        }else{
			        // obt@t
					System::Threading::Thread::Sleep(10);	// ҋ@
			        if(++Drv>=DRV_NUM)	// ύX
				        Drv=0;
		        }
	        }else if(fix_num[Drv]>=data_num && CInfo.status==1){
		        // MO
		        finished[Drv]=1;
		        LogData[Drv,data_num].data32=(int)CInfo.enc;
		        LogData[Drv,data_num].trj32=CInfo.trj;
		        if(++Drv>=DRV_NUM)
			        Drv=0;
    			
		        // DDA擾
		        for(i=0,j=0;i<DRV_NUM;i++)
			        j+=finished[Drv];
		        if(j>=DRV_NUM)
			        break;
		        else
			        continue;	// DDA
	        }else{
		        rest_num[Drv]-=send_num;	// cf[^Zo
		        comp_num[Drv]+=send_num;	// ]f[^Zo
		        if(++Drv>=DRV_NUM){
			        all_fixed=0;
			        Drv=0;
		        }
	        }
        }

        // DDA~
        strBuf="*:S";
        iRc=api->SendCom(iDevSel,strBuf);
        if(iRc==MovoAPI::MOVO_FAILURE)goto COM_ERR;

        // xt@C(Oԍr)
        for(i=0;i<DDA_LINE;i++){
	        for(Drv=0;Drv<DRV_NUM;Drv++){
		        // FLogData̐擪Ɋi[f[^
		        // ODDA̍ŏIf[^ɑ΂EncoderlŁADDAʂł͂ȂB
		        if(DdaData[Drv,i].trj32!=LogData[Drv,i+1].trj32){
			        Console::WriteLine("Verification failed");
			        return -1;
		        }
	        }
        }

        // Oo
        strBuf = "";
		logfile = gcnew System::IO::StreamWriter(filename);
        for(i = 0;i<DDA_LINE;i++){
            for(Drv = 0;Drv<DRV_NUM;Drv++){
                strBuf += DdaData[Drv, i].trj32.ToString() + "," + DdaData[Drv, i].data32.ToString() + "," + LogData[Drv, i].data32.ToString();
                if(Drv!= DRV_NUM - 1){
                    strBuf += ",";
                }
            }
            logfile->WriteLine(strBuf);
            strBuf = "";
        }
        logfile->Close();

        return 0;

    COM_ERR:
        // ʐMG[
        api->GetErrorText(iDevSel, strBuf);
        strBuf="Error : " + strBuf;
        Console::WriteLine(strBuf);
        return -1;
    }
};

// ============================================================================
// Gg[|Cg
// ============================================================================
int main(array<System::String ^> ^args)
{
	int iRc;
	String ^line;

	CPP_ApiSample2 sample;
	iRc=sample.Initialize();

    if(iRc != 0)
    {
        // s
		Console::WriteLine("Initialization failed (Hit Enter to exit)");
		line = Console::ReadLine();
        return -1;
    }

    sample.ExecDda();
	Console::WriteLine("Finished (Hit Enter to exit)");
	line = Console::ReadLine();

	return 0;
}
